# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from importlib import import_module
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from dataforseo_client.models.google_finance_about_serp_element_item import GoogleFinanceAboutSerpElementItem
    from dataforseo_client.models.google_finance_asset_pair_element_serp_element_item import GoogleFinanceAssetPairElementSerpElementItem
    from dataforseo_client.models.google_finance_compare_to_serp_element_item import GoogleFinanceCompareToSerpElementItem
    from dataforseo_client.models.google_finance_details_serp_element_item import GoogleFinanceDetailsSerpElementItem
    from dataforseo_client.models.google_finance_earnings_calendar_serp_element_item import GoogleFinanceEarningsCalendarSerpElementItem
    from dataforseo_client.models.google_finance_explore_market_trends_serp_element_item import GoogleFinanceExploreMarketTrendsSerpElementItem
    from dataforseo_client.models.google_finance_financial_serp_element_item import GoogleFinanceFinancialSerpElementItem
    from dataforseo_client.models.google_finance_futures_chain_serp_element_item import GoogleFinanceFuturesChainSerpElementItem
    from dataforseo_client.models.google_finance_hero_groups_serp_element_item import GoogleFinanceHeroGroupsSerpElementItem
    from dataforseo_client.models.google_finance_interested_serp_element_item import GoogleFinanceInterestedSerpElementItem
    from dataforseo_client.models.google_finance_market_index_element_serp_element_item import GoogleFinanceMarketIndexElementSerpElementItem
    from dataforseo_client.models.google_finance_market_instrument_element_serp_element_item import GoogleFinanceMarketInstrumentElementSerpElementItem
    from dataforseo_client.models.google_finance_market_trends_serp_element_item import GoogleFinanceMarketTrendsSerpElementItem
    from dataforseo_client.models.google_finance_most_followed_serp_element_item import GoogleFinanceMostFollowedSerpElementItem
    from dataforseo_client.models.google_finance_news_serp_element_item import GoogleFinanceNewsSerpElementItem
    from dataforseo_client.models.google_finance_people_also_search_serp_element_item import GoogleFinancePeopleAlsoSearchSerpElementItem
    from dataforseo_client.models.google_finance_quote_serp_element_item import GoogleFinanceQuoteSerpElementItem

class BaseGoogleFinanceSerpElementItem(BaseModel):
    """
    BaseGoogleFinanceSerpElementItem
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="type of element")
    __properties: ClassVar[List[str]] = ["type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'type'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'google_finance_about': 'GoogleFinanceAboutSerpElementItem','google_finance_asset_pair_element': 'GoogleFinanceAssetPairElementSerpElementItem','google_finance_compare_to': 'GoogleFinanceCompareToSerpElementItem','google_finance_details': 'GoogleFinanceDetailsSerpElementItem','google_finance_earnings_calendar': 'GoogleFinanceEarningsCalendarSerpElementItem','google_finance_explore_market_trends': 'GoogleFinanceExploreMarketTrendsSerpElementItem','google_finance_financial': 'GoogleFinanceFinancialSerpElementItem','google_finance_futures_chain': 'GoogleFinanceFuturesChainSerpElementItem','google_finance_hero_groups': 'GoogleFinanceHeroGroupsSerpElementItem','google_finance_interested': 'GoogleFinanceInterestedSerpElementItem','google_finance_market_index_element': 'GoogleFinanceMarketIndexElementSerpElementItem','google_finance_market_instrument_element': 'GoogleFinanceMarketInstrumentElementSerpElementItem','google_finance_market_trends': 'GoogleFinanceMarketTrendsSerpElementItem','google_finance_most_followed': 'GoogleFinanceMostFollowedSerpElementItem','google_finance_news': 'GoogleFinanceNewsSerpElementItem','google_finance_people_also_search': 'GoogleFinancePeopleAlsoSearchSerpElementItem','google_finance_quote': 'GoogleFinanceQuoteSerpElementItem'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[GoogleFinanceAboutSerpElementItem, GoogleFinanceAssetPairElementSerpElementItem, GoogleFinanceCompareToSerpElementItem, GoogleFinanceDetailsSerpElementItem, GoogleFinanceEarningsCalendarSerpElementItem, GoogleFinanceExploreMarketTrendsSerpElementItem, GoogleFinanceFinancialSerpElementItem, GoogleFinanceFuturesChainSerpElementItem, GoogleFinanceHeroGroupsSerpElementItem, GoogleFinanceInterestedSerpElementItem, GoogleFinanceMarketIndexElementSerpElementItem, GoogleFinanceMarketInstrumentElementSerpElementItem, GoogleFinanceMarketTrendsSerpElementItem, GoogleFinanceMostFollowedSerpElementItem, GoogleFinanceNewsSerpElementItem, GoogleFinancePeopleAlsoSearchSerpElementItem, GoogleFinanceQuoteSerpElementItem]]:
        """Create an instance of BaseGoogleFinanceSerpElementItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[GoogleFinanceAboutSerpElementItem, GoogleFinanceAssetPairElementSerpElementItem, GoogleFinanceCompareToSerpElementItem, GoogleFinanceDetailsSerpElementItem, GoogleFinanceEarningsCalendarSerpElementItem, GoogleFinanceExploreMarketTrendsSerpElementItem, GoogleFinanceFinancialSerpElementItem, GoogleFinanceFuturesChainSerpElementItem, GoogleFinanceHeroGroupsSerpElementItem, GoogleFinanceInterestedSerpElementItem, GoogleFinanceMarketIndexElementSerpElementItem, GoogleFinanceMarketInstrumentElementSerpElementItem, GoogleFinanceMarketTrendsSerpElementItem, GoogleFinanceMostFollowedSerpElementItem, GoogleFinanceNewsSerpElementItem, GoogleFinancePeopleAlsoSearchSerpElementItem, GoogleFinanceQuoteSerpElementItem]]:
        """Create an instance of BaseGoogleFinanceSerpElementItem from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type ==  'GoogleFinanceAboutSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_about_serp_element_item").GoogleFinanceAboutSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceAssetPairElementSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_asset_pair_element_serp_element_item").GoogleFinanceAssetPairElementSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceCompareToSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_compare_to_serp_element_item").GoogleFinanceCompareToSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceDetailsSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_details_serp_element_item").GoogleFinanceDetailsSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceEarningsCalendarSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_earnings_calendar_serp_element_item").GoogleFinanceEarningsCalendarSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceExploreMarketTrendsSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_explore_market_trends_serp_element_item").GoogleFinanceExploreMarketTrendsSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceFinancialSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_financial_serp_element_item").GoogleFinanceFinancialSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceFuturesChainSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_futures_chain_serp_element_item").GoogleFinanceFuturesChainSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceHeroGroupsSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_hero_groups_serp_element_item").GoogleFinanceHeroGroupsSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceInterestedSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_interested_serp_element_item").GoogleFinanceInterestedSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceMarketIndexElementSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_market_index_element_serp_element_item").GoogleFinanceMarketIndexElementSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceMarketInstrumentElementSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_market_instrument_element_serp_element_item").GoogleFinanceMarketInstrumentElementSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceMarketTrendsSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_market_trends_serp_element_item").GoogleFinanceMarketTrendsSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceMostFollowedSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_most_followed_serp_element_item").GoogleFinanceMostFollowedSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceNewsSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_news_serp_element_item").GoogleFinanceNewsSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinancePeopleAlsoSearchSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_people_also_search_serp_element_item").GoogleFinancePeopleAlsoSearchSerpElementItem.from_dict(obj)
        if object_type ==  'GoogleFinanceQuoteSerpElementItem':
            return import_module("dataforseo_client.models.google_finance_quote_serp_element_item").GoogleFinanceQuoteSerpElementItem.from_dict(obj)

        raise ValueError("BaseGoogleFinanceSerpElementItem failed to lookup discriminator value from " +
                            json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                            ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


