# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from importlib import import_module
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from dataforseo_client.models.google_trends_graph_element_item import GoogleTrendsGraphElementItem
    from dataforseo_client.models.google_trends_map_element_item import GoogleTrendsMapElementItem
    from dataforseo_client.models.google_trends_queries_list_element_item import GoogleTrendsQueriesListElementItem
    from dataforseo_client.models.google_trends_topics_list_element_item import GoogleTrendsTopicsListElementItem

class BaseGoogleTrendsItem(BaseModel):
    """
    BaseGoogleTrendsItem
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="type of element")
    position: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="the alignment of the element in Google Trends can take the following values: 1, 2, 3, 4, etc.")
    title: Optional[StrictStr] = Field(default=None, description="title of the element in Google Trends")
    keywords: Optional[List[Optional[StrictStr]]] = Field(default=None, description="relevant keywords the data included in the google_trends_graph element is based on the keywords listed in this array")
    __properties: ClassVar[List[str]] = ["type", "position", "title", "keywords"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'type'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'google_trends_graph': 'GoogleTrendsGraphElementItem','google_trends_map': 'GoogleTrendsMapElementItem','google_trends_queries_list': 'GoogleTrendsQueriesListElementItem','google_trends_topics_list': 'GoogleTrendsTopicsListElementItem'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[GoogleTrendsGraphElementItem, GoogleTrendsMapElementItem, GoogleTrendsQueriesListElementItem, GoogleTrendsTopicsListElementItem]]:
        """Create an instance of BaseGoogleTrendsItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        # set to None if position (nullable) is None
        # and model_fields_set contains the field
        if self.position is None and "position" in self.model_fields_set:
            _dict['position'] = None

        # set to None if title (nullable) is None
        # and model_fields_set contains the field
        if self.title is None and "title" in self.model_fields_set:
            _dict['title'] = None

        # set to None if keywords (nullable) is None
        # and model_fields_set contains the field
        if self.keywords is None and "keywords" in self.model_fields_set:
            _dict['keywords'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[GoogleTrendsGraphElementItem, GoogleTrendsMapElementItem, GoogleTrendsQueriesListElementItem, GoogleTrendsTopicsListElementItem]]:
        """Create an instance of BaseGoogleTrendsItem from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type ==  'GoogleTrendsGraphElementItem':
            return import_module("dataforseo_client.models.google_trends_graph_element_item").GoogleTrendsGraphElementItem.from_dict(obj)
        if object_type ==  'GoogleTrendsMapElementItem':
            return import_module("dataforseo_client.models.google_trends_map_element_item").GoogleTrendsMapElementItem.from_dict(obj)
        if object_type ==  'GoogleTrendsQueriesListElementItem':
            return import_module("dataforseo_client.models.google_trends_queries_list_element_item").GoogleTrendsQueriesListElementItem.from_dict(obj)
        if object_type ==  'GoogleTrendsTopicsListElementItem':
            return import_module("dataforseo_client.models.google_trends_topics_list_element_item").GoogleTrendsTopicsListElementItem.from_dict(obj)

        raise ValueError("BaseGoogleTrendsItem failed to lookup discriminator value from " +
                            json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                            ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


