# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GoogleFinanceFuturesChainMarkets(BaseModel):
    """
    GoogleFinanceFuturesChainMarkets
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="type of element")
    expiration_timestamp: Optional[StrictStr] = Field(default=None, description="futures’ date and time of expiration in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00” example: 2025-02-10 09:40:00 +00:00")
    symbol: Optional[StrictStr] = Field(default=None, description="futures’ symbol")
    price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="price of the market instrument price of the market instrument at a given timestamp")
    price_currency: Optional[StrictStr] = Field(default=None, description="currency of the price value")
    price_delta: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="change in price of the market instrument change in price at a given timestamp")
    percentage_delta: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="percentage of change in value of the market index")
    trend: Optional[StrictStr] = Field(default=None, description="growth trend of the market index possible values: up, down, stable")
    __properties: ClassVar[List[str]] = ["type", "expiration_timestamp", "symbol", "price", "price_currency", "price_delta", "percentage_delta", "trend"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleFinanceFuturesChainMarkets from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if type (nullable) is None
        # and model_fields_set contains the field
        if self.type is None and "type" in self.model_fields_set:
            _dict['type'] = None

        # set to None if expiration_timestamp (nullable) is None
        # and model_fields_set contains the field
        if self.expiration_timestamp is None and "expiration_timestamp" in self.model_fields_set:
            _dict['expiration_timestamp'] = None

        # set to None if symbol (nullable) is None
        # and model_fields_set contains the field
        if self.symbol is None and "symbol" in self.model_fields_set:
            _dict['symbol'] = None

        # set to None if price (nullable) is None
        # and model_fields_set contains the field
        if self.price is None and "price" in self.model_fields_set:
            _dict['price'] = None

        # set to None if price_currency (nullable) is None
        # and model_fields_set contains the field
        if self.price_currency is None and "price_currency" in self.model_fields_set:
            _dict['price_currency'] = None

        # set to None if price_delta (nullable) is None
        # and model_fields_set contains the field
        if self.price_delta is None and "price_delta" in self.model_fields_set:
            _dict['price_delta'] = None

        # set to None if percentage_delta (nullable) is None
        # and model_fields_set contains the field
        if self.percentage_delta is None and "percentage_delta" in self.model_fields_set:
            _dict['percentage_delta'] = None

        # set to None if trend (nullable) is None
        # and model_fields_set contains the field
        if self.trend is None and "trend" in self.model_fields_set:
            _dict['trend'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleFinanceFuturesChainMarkets from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "expiration_timestamp": obj.get("expiration_timestamp"),
            "symbol": obj.get("symbol"),
            "price": obj.get("price"),
            "price_currency": obj.get("price_currency"),
            "price_delta": obj.get("price_delta"),
            "percentage_delta": obj.get("percentage_delta"),
            "trend": obj.get("trend")
        })
        return _obj


