# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MerchantGoogleSellersAdUrlResultInfo(BaseModel):
    """
    MerchantGoogleSellersAdUrlResultInfo
    """ # noqa: E501
    ad_aclk: Optional[StrictStr] = Field(default=None, description="unique ad click referral parameter")
    ad_url: Optional[StrictStr] = Field(default=None, description="full URL of the advertisement")
    ad_url_redirects: Optional[List[Optional[StrictStr]]] = Field(default=None, description="URLs where the link from Google Shopping redirects before reaching a final URL includes up to 10 URLs of the ad’s redirect path to the seller’s ad_url")
    __properties: ClassVar[List[str]] = ["ad_aclk", "ad_url", "ad_url_redirects"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MerchantGoogleSellersAdUrlResultInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if ad_aclk (nullable) is None
        # and model_fields_set contains the field
        if self.ad_aclk is None and "ad_aclk" in self.model_fields_set:
            _dict['ad_aclk'] = None

        # set to None if ad_url (nullable) is None
        # and model_fields_set contains the field
        if self.ad_url is None and "ad_url" in self.model_fields_set:
            _dict['ad_url'] = None

        # set to None if ad_url_redirects (nullable) is None
        # and model_fields_set contains the field
        if self.ad_url_redirects is None and "ad_url_redirects" in self.model_fields_set:
            _dict['ad_url_redirects'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MerchantGoogleSellersAdUrlResultInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ad_aclk": obj.get("ad_aclk"),
            "ad_url": obj.get("ad_url"),
            "ad_url_redirects": obj.get("ad_url_redirects")
        })
        return _obj


